// Generated by CoffeeScript 1.7.1
(function() {
  var $, AnnotationRegistry, Annotator, Delegator, Editor, Factory, Notification, NullStore, Plugin, Range, Util, Viewer, Widget, extend, g, handleError, notification, _Annotator, _ref, _t,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  $ = require('jquery');

  extend = require('backbone-extend-standalone');

  Delegator = require('./delegator');

  Range = require('./range');

  Util = require('./util');

  Widget = require('./widget');

  Viewer = require('./viewer');

  Editor = require('./editor');

  Notification = require('./notification');

  Factory = require('./factory');

  Plugin = require('./plugin');

  AnnotationRegistry = require('./annotations');

  NullStore = require('./nullstore');

  _t = Util.TranslationString;

  _Annotator = this.Annotator;

  handleError = function() {
    return console.error.apply(console, arguments);
  };

  Annotator = (function(_super) {
    __extends(Annotator, _super);

    Annotator.prototype.events = {
      ".annotator-adder button click": "onAdderClick",
      ".annotator-adder button mousedown": "onAdderMousedown",
      ".annotator-hl mouseover": "onHighlightMouseover",
      ".annotator-hl mouseout": "startViewerHideTimer"
    };

    Annotator.prototype.html = {
      adder: '<div class="annotator-adder"><button type="button">' + _t('Annotate') + '</button></div>',
      wrapper: '<div class="annotator-wrapper"></div>'
    };

    Annotator.prototype.options = {
      store: null,
      readOnly: false,
      loadQuery: {}
    };

    Annotator.prototype.plugins = {};

    Annotator.prototype.editor = null;

    Annotator.prototype.viewer = null;

    Annotator.prototype.selectedRanges = null;

    Annotator.prototype.mouseIsDown = false;

    Annotator.prototype.ignoreMouseup = false;

    Annotator.prototype.viewerHideTimer = null;

    function Annotator(element, options) {
      this.onEditAnnotation = __bind(this.onEditAnnotation, this);
      this.onAdderClick = __bind(this.onAdderClick, this);
      this.onAdderMousedown = __bind(this.onAdderMousedown, this);
      this.onHighlightMouseover = __bind(this.onHighlightMouseover, this);
      this.checkForEndSelection = __bind(this.checkForEndSelection, this);
      this.checkForStartSelection = __bind(this.checkForStartSelection, this);
      this.clearViewerHideTimer = __bind(this.clearViewerHideTimer, this);
      this.startViewerHideTimer = __bind(this.startViewerHideTimer, this);
      this.showViewer = __bind(this.showViewer, this);
      this.onEditorSubmit = __bind(this.onEditorSubmit, this);
      this.onEditorHide = __bind(this.onEditorHide, this);
      this.showEditor = __bind(this.showEditor, this);
      var factory;
      this.options = $.extend(true, {}, this.options, options);
      this.plugins = {};
      Annotator._instances.push(this);
      Annotator.Plugin._rebindOldPlugins();
      if (!Annotator.supported()) {
        return this;
      }
      if (element) {
        factory = new Factory();
        if (this.options.store) {
          factory.setStore(this.options.store.type, this.options.store);
        } else {
          factory.setStore(NullStore);
        }
        factory.configureInstance(this);
        this.attach(element);
      }
    }

    Annotator.prototype.configure = function(config) {
      var klass, name, p, plugins, _i, _len, _ref;
      this.store = config.store, plugins = config.plugins;
      this.plugins = {};
      for (_i = 0, _len = plugins.length; _i < _len; _i++) {
        p = plugins[_i];
        _ref = Annotator.Plugin._ctors;
        for (name in _ref) {
          klass = _ref[name];
          if (p instanceof klass) {
            this.plugins[name] = p;
          }
        }
      }
      this.annotations = new AnnotationRegistry();
      return this.annotations.configure({
        core: this
      });
    };

    Annotator.prototype.attach = function(element) {
      var p, _i, _len, _ref, _results;
      this.element = $(element);
      this.addEvents();
      if (!this.options.readOnly) {
        this._setupDocumentEvents();
      }
      this._setupWrapper()._setupViewer()._setupEditor();
      this._setupDynamicStyle();
      this.adder = $(this.html.adder).appendTo(this.wrapper).hide();
      if (this.options.loadQuery) {
        this.load(this.options.loadQuery);
      }
      _ref = this.plugins;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        p = _ref[_i];
        p.annotator = this;
        _results.push(typeof p.pluginInit === "function" ? p.pluginInit() : void 0);
      }
      return _results;
    };

    Annotator.extend = extend;

    Annotator.prototype._setupWrapper = function() {
      this.wrapper = $(this.html.wrapper);
      this.element.find('script').remove();
      this.element.wrapInner(this.wrapper);
      this.wrapper = this.element.find('.annotator-wrapper');
      return this;
    };

    Annotator.prototype._setupViewer = function() {
      this.viewer = new Annotator.Viewer({
        readOnly: this.options.readOnly
      });
      this.viewer.hide().on("edit", this.onEditAnnotation).on("delete", (function(_this) {
        return function(annotation) {
          _this.viewer.hide();
          _this.publish('beforeAnnotationDeleted', [annotation]);
          _this.cleanupAnnotation(annotation);
          return _this.annotations["delete"](annotation).done(function() {
            return _this.publish('annotationDeleted', [annotation]);
          });
        };
      })(this)).addField({
        load: (function(_this) {
          return function(field, annotation) {
            if (annotation.text) {
              $(field).html(Util.escape(annotation.text));
            } else {
              $(field).html("<i>" + (_t('No Comment')) + "</i>");
            }
            return _this.publish('annotationViewerTextField', [field, annotation]);
          };
        })(this)
      }).element.appendTo(this.wrapper).bind({
        "mouseover": this.clearViewerHideTimer,
        "mouseout": this.startViewerHideTimer
      });
      return this;
    };

    Annotator.prototype._setupEditor = function() {
      this.editor = new Annotator.Editor();
      this.editor.hide().on('hide', this.onEditorHide).on('save', this.onEditorSubmit).addField({
        type: 'textarea',
        label: _t('Comments') + '\u2026',
        load: function(field, annotation) {
          return $(field).find('textarea').val(annotation.text || '');
        },
        submit: function(field, annotation) {
          return annotation.text = $(field).find('textarea').val();
        }
      });
      this.editor.element.appendTo(this.wrapper);
      return this;
    };

    Annotator.prototype._setupDocumentEvents = function() {
      $(document).bind({
        "mouseup": this.checkForEndSelection,
        "mousedown": this.checkForStartSelection
      });
      return this;
    };

    Annotator.prototype._setupDynamicStyle = function() {
      var max, notclasses, sel, style, x;
      style = $('#annotator-dynamic-style');
      if (!style.length) {
        style = $('<style id="annotator-dynamic-style"></style>').appendTo(document.head);
      }
      notclasses = ['adder', 'outer', 'notice', 'filter'];
      sel = '*' + ((function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = notclasses.length; _i < _len; _i++) {
          x = notclasses[_i];
          _results.push(":not(.annotator-" + x + ")");
        }
        return _results;
      })()).join('');
      max = Util.maxZIndex($(document.body).find(sel));
      max = Math.max(max, 1000);
      style.text([".annotator-adder, .annotator-outer, .annotator-notice {", "  z-index: " + (max + 20) + ";", "}", ".annotator-filter {", "  z-index: " + (max + 10) + ";", "}"].join("\n"));
      return this;
    };

    Annotator.prototype.load = function(query) {
      return this.annotations.query(query).then((function(_this) {
        return function(annotations, meta) {
          return _this.loadAnnotations(annotations);
        };
      })(this));
    };

    Annotator.prototype.destroy = function() {
      var idx, plugin, _i, _len, _ref;
      $(document).unbind({
        "mouseup": this.checkForEndSelection,
        "mousedown": this.checkForStartSelection
      });
      $('#annotator-dynamic-style').remove();
      this.adder.remove();
      this.viewer.destroy();
      this.editor.destroy();
      this.wrapper.find('.annotator-hl').each(function() {
        $(this).contents().insertBefore(this);
        return $(this).remove();
      });
      this.wrapper.contents().insertBefore(this.wrapper);
      this.wrapper.remove();
      this.element.data('annotator', null);
      _ref = this.plugins;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        plugin = _ref[_i];
        plugin.destroy();
      }
      this.removeEvents();
      idx = Annotator._instances.indexOf(this);
      if (idx !== -1) {
        return Annotator._instances.splice(idx, 1);
      }
    };

    Annotator.prototype.getSelectedRanges = function() {
      var browserRange, i, normedRange, r, ranges, rangesToIgnore, selection, _i, _len;
      selection = Util.getGlobal().getSelection();
      ranges = [];
      rangesToIgnore = [];
      if (!selection.isCollapsed) {
        ranges = (function() {
          var _i, _ref, _results;
          _results = [];
          for (i = _i = 0, _ref = selection.rangeCount; 0 <= _ref ? _i < _ref : _i > _ref; i = 0 <= _ref ? ++_i : --_i) {
            r = selection.getRangeAt(i);
            browserRange = new Range.BrowserRange(r);
            normedRange = browserRange.normalize().limit(this.wrapper[0]);
            if (normedRange === null) {
              rangesToIgnore.push(r);
            }
            _results.push(normedRange);
          }
          return _results;
        }).call(this);
        selection.removeAllRanges();
      }
      for (_i = 0, _len = rangesToIgnore.length; _i < _len; _i++) {
        r = rangesToIgnore[_i];
        selection.addRange(r);
      }
      return $.grep(ranges, function(range) {
        if (range) {
          selection.addRange(range.toRange());
        }
        return range;
      });
    };

    Annotator.prototype.setupAnnotation = function(annotation) {
      var e, normed, normedRanges, r, root, _i, _j, _len, _len1, _ref;
      root = this.wrapper[0];
      normedRanges = [];
      _ref = annotation.ranges;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        r = _ref[_i];
        try {
          normedRanges.push(Range.sniff(r).normalize(root));
        } catch (_error) {
          e = _error;
          if (e instanceof Range.RangeError) {
            this.publish('rangeNormalizeFail', [annotation, r, e]);
          } else {
            throw e;
          }
        }
      }
      annotation.quote = [];
      annotation.ranges = [];
      annotation._local = {};
      annotation._local.highlights = [];
      for (_j = 0, _len1 = normedRanges.length; _j < _len1; _j++) {
        normed = normedRanges[_j];
        annotation.quote.push($.trim(normed.text()));
        annotation.ranges.push(normed.serialize(this.wrapper[0], '.annotator-hl'));
        $.merge(annotation._local.highlights, this.highlightRange(normed));
      }
      annotation.quote = annotation.quote.join(' / ');
      $(annotation._local.highlights).data('annotation', annotation);
      return annotation;
    };

    Annotator.prototype.cleanupAnnotation = function(annotation) {
      var h, _i, _len, _ref, _ref1;
      if (((_ref = annotation._local) != null ? _ref.highlights : void 0) != null) {
        _ref1 = annotation._local.highlights;
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          h = _ref1[_i];
          if (h.parentNode != null) {
            $(h).replaceWith(h.childNodes);
          }
        }
        delete annotation._local.highlights;
      }
      return annotation;
    };

    Annotator.prototype.loadAnnotations = function(annotations) {
      var clone, loader;
      if (annotations == null) {
        annotations = [];
      }
      loader = (function(_this) {
        return function(annList) {
          var n, now, _i, _len;
          if (annList == null) {
            annList = [];
          }
          now = annList.splice(0, 10);
          for (_i = 0, _len = now.length; _i < _len; _i++) {
            n = now[_i];
            _this.setupAnnotation(n);
          }
          if (annList.length > 0) {
            return setTimeout((function() {
              return loader(annList);
            }), 10);
          } else {
            return _this.publish('annotationsLoaded', [clone]);
          }
        };
      })(this);
      clone = annotations.slice();
      loader(annotations);
      return this;
    };

    Annotator.prototype.dumpAnnotations = function() {
      var _ref;
      if (((_ref = this.store) != null ? _ref.dumpAnnotations : void 0) != null) {
        return this.store.dumpAnnotations();
      } else {
        console.warn(_t("Can't dump annotations without store plugin."));
        return false;
      }
    };

    Annotator.prototype.highlightRange = function(normedRange, cssClass) {
      var hl, node, white, _i, _len, _ref, _results;
      if (cssClass == null) {
        cssClass = 'annotator-hl';
      }
      white = /^\s*$/;
      hl = $("<span class='" + cssClass + "'></span>");
      _ref = normedRange.textNodes();
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        node = _ref[_i];
        if (!white.test(node.nodeValue)) {
          _results.push($(node).wrapAll(hl).parent().show()[0]);
        }
      }
      return _results;
    };

    Annotator.prototype.highlightRanges = function(normedRanges, cssClass) {
      var highlights, r, _i, _len;
      if (cssClass == null) {
        cssClass = 'annotator-hl';
      }
      highlights = [];
      for (_i = 0, _len = normedRanges.length; _i < _len; _i++) {
        r = normedRanges[_i];
        $.merge(highlights, this.highlightRange(r, cssClass));
      }
      return highlights;
    };

    Annotator.prototype.addPlugin = function(name, options) {
      var klass, plug;
      klass = Annotator.Plugin.fetch(name);
      if (typeof klass === 'function') {
        plug = new klass(this.element[0], options);
        plug.annotator = this;
        if (typeof plug.pluginInit === "function") {
          plug.pluginInit();
        }
        this.plugins[name] = plug;
      } else {
        console.error(_t("Could not load ") + name + _t(" plugin. Have you included the appropriate <script> tag?"));
      }
      return this;
    };

    Annotator.prototype.editAnnotation = function(annotation, position) {
      var dfd, reject, resolve;
      dfd = $.Deferred();
      resolve = dfd.resolve.bind(dfd, annotation);
      reject = dfd.reject.bind(dfd, annotation);
      this.showEditor(annotation, position);
      this.subscribe('annotationEditorSubmit', resolve);
      this.once('annotationEditorHidden', (function(_this) {
        return function() {
          _this.unsubscribe('annotationEditorSubmit', resolve);
          if (dfd.state() === 'pending') {
            return reject();
          }
        };
      })(this));
      return dfd.promise();
    };

    Annotator.prototype.showEditor = function(annotation, location) {
      this.editor.element.css(location);
      this.editor.load(annotation);
      this.publish('annotationEditorShown', [this.editor, annotation]);
      return this;
    };

    Annotator.prototype.onEditorHide = function() {
      this.publish('annotationEditorHidden', [this.editor]);
      return this.ignoreMouseup = false;
    };

    Annotator.prototype.onEditorSubmit = function(annotation) {
      return this.publish('annotationEditorSubmit', [this.editor, annotation]);
    };

    Annotator.prototype.showViewer = function(annotations, location) {
      this.viewer.element.css(location);
      this.viewer.load(annotations);
      return this.publish('annotationViewerShown', [this.viewer, annotations]);
    };

    Annotator.prototype.startViewerHideTimer = function() {
      if (!this.viewerHideTimer) {
        return this.viewerHideTimer = setTimeout(this.viewer.hide, 250);
      }
    };

    Annotator.prototype.clearViewerHideTimer = function() {
      clearTimeout(this.viewerHideTimer);
      return this.viewerHideTimer = false;
    };

    Annotator.prototype.checkForStartSelection = function(event) {
      if (!(event && this.isAnnotator(event.target))) {
        this.startViewerHideTimer();
      }
      return this.mouseIsDown = true;
    };

    Annotator.prototype.checkForEndSelection = function(event) {
      var container, range, _i, _len, _ref;
      this.mouseIsDown = false;
      if (this.ignoreMouseup) {
        return;
      }
      this.selectedRanges = this.getSelectedRanges();
      _ref = this.selectedRanges;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        range = _ref[_i];
        container = range.commonAncestor;
        if ($(container).hasClass('annotator-hl')) {
          container = $(container).parents('[class!=annotator-hl]')[0];
        }
        if (this.isAnnotator(container)) {
          return;
        }
      }
      if (event && this.selectedRanges.length) {
        return this.adder.css(Util.mousePosition(event, this.wrapper[0])).show();
      } else {
        return this.adder.hide();
      }
    };

    Annotator.prototype.isAnnotator = function(element) {
      return !!$(element).parents().addBack().filter('[class^=annotator-]').not(this.wrapper).length;
    };

    Annotator.prototype.onHighlightMouseover = function(event) {
      var annotations;
      this.clearViewerHideTimer();
      if (this.mouseIsDown) {
        return false;
      }
      if (this.viewer.isShown()) {
        this.viewer.hide();
      }
      annotations = $(event.target).parents('.annotator-hl').addBack().map(function() {
        return $(this).data("annotation");
      }).toArray();
      return this.showViewer(annotations, Util.mousePosition(event, this.wrapper[0]));
    };

    Annotator.prototype.onAdderMousedown = function(event) {
      if (event != null) {
        event.preventDefault();
      }
      return this.ignoreMouseup = true;
    };

    Annotator.prototype.onAdderClick = function(event) {
      var annotation, position;
      if (event != null) {
        event.preventDefault();
      }
      position = this.adder.position();
      this.adder.hide();
      annotation = {
        ranges: this.selectedRanges
      };
      return $.when(annotation).done((function(_this) {
        return function(annotation) {
          return _this.publish('beforeAnnotationCreated', [annotation]);
        };
      })(this)).then((function(_this) {
        return function(annotation) {
          return _this.setupAnnotation(annotation);
        };
      })(this)).done(function(annotation) {
        return $(annotation._local.highlights).addClass('annotator-hl-temporary');
      }).then((function(_this) {
        return function(annotation) {
          return _this.editAnnotation(annotation, position);
        };
      })(this)).then((function(_this) {
        return function(annotation) {
          return _this.annotations.create(annotation).fail(handleError);
        };
      })(this)).done(function(annotation) {
        return $(annotation._local.highlights).removeClass('annotator-hl-temporary');
      }).done((function(_this) {
        return function(annotation) {
          return _this.publish('annotationCreated', [annotation]);
        };
      })(this)).fail(this.cleanupAnnotation);
    };

    Annotator.prototype.onEditAnnotation = function(annotation) {
      var position;
      position = this.viewer.element.position();
      this.viewer.hide();
      return $.when(annotation).done((function(_this) {
        return function(annotation) {
          return _this.publish('beforeAnnotationUpdated', [annotation]);
        };
      })(this)).then((function(_this) {
        return function(annotation) {
          return _this.editAnnotation(annotation, position);
        };
      })(this)).then((function(_this) {
        return function(annotation) {
          return _this.annotations.update(annotation).fail(handleError);
        };
      })(this)).done((function(_this) {
        return function(annotation) {
          return _this.publish('annotationUpdated', [annotation]);
        };
      })(this));
    };

    return Annotator;

  })(Delegator);

  Annotator.Factory = (function(_super) {
    __extends(Factory, _super);

    function Factory(core) {
      if (core == null) {
        core = Annotator;
      }
      Factory.__super__.constructor.call(this, core);
    }

    return Factory;

  })(Factory);

  g = Util.getGlobal();

  if (((_ref = g.document) != null ? _ref.evaluate : void 0) == null) {
    $.getScript('http://assets.annotateit.org/vendor/xpath.min.js');
  }

  if (g.getSelection == null) {
    $.getScript('http://assets.annotateit.org/vendor/ierange.min.js');
  }

  if (g.JSON == null) {
    $.getScript('http://assets.annotateit.org/vendor/json2.min.js');
  }

  if (g.Node == null) {
    g.Node = {
      ELEMENT_NODE: 1,
      ATTRIBUTE_NODE: 2,
      TEXT_NODE: 3,
      CDATA_SECTION_NODE: 4,
      ENTITY_REFERENCE_NODE: 5,
      ENTITY_NODE: 6,
      PROCESSING_INSTRUCTION_NODE: 7,
      COMMENT_NODE: 8,
      DOCUMENT_NODE: 9,
      DOCUMENT_TYPE_NODE: 10,
      DOCUMENT_FRAGMENT_NODE: 11,
      NOTATION_NODE: 12
    };
  }

  Annotator.Delegator = Delegator;

  Annotator.Range = Range;

  Annotator.Util = Util;

  Annotator.Widget = Widget;

  Annotator.Viewer = Viewer;

  Annotator.Editor = Editor;

  Annotator.Notification = Notification;

  Annotator.Plugin = Plugin;

  notification = new Notification();

  Annotator.showNotification = notification.show;

  Annotator.hideNotification = notification.hide;

  Annotator.Plugin.register('NullStore', NullStore);

  Annotator._instances = [];

  Annotator._t = _t;

  Annotator.supported = function() {
    return Util.getGlobal().getSelection != null;
  };

  Annotator.noConflict = function() {
    Util.getGlobal().Annotator = _Annotator;
    return Annotator;
  };

  module.exports = Annotator;

}).call(this);
