// Generated by CoffeeScript 1.7.1
(function() {
  var $, BackboneEvents, Delegator, natives, _isCustomEvent, _parseEvents,
    __slice = [].slice,
    __hasProp = {}.hasOwnProperty;

  $ = require('jquery');

  Delegator = (function() {
    Delegator.prototype.events = {};

    Delegator.prototype.options = {};

    Delegator.prototype.element = null;

    function Delegator(element, options) {
      this.options = $.extend(true, {}, this.options, options);
      this.element = $(element);
      this.addEvents();
    }

    Delegator.prototype.addEvents = function() {
      var event, _i, _len, _ref, _results;
      _ref = _parseEvents(this.events);
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        event = _ref[_i];
        _results.push(this._addEvent(event.selector, event.event, event.functionName));
      }
      return _results;
    };

    Delegator.prototype.removeEvents = function() {
      var event, _i, _len, _ref, _results;
      _ref = _parseEvents(this.events);
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        event = _ref[_i];
        _results.push(this._removeEvent(event.selector, event.event, event.functionName));
      }
      return _results;
    };

    Delegator.prototype._addEvent = function(selector, event, functionName) {
      var closure;
      closure = (function(_this) {
        return function() {
          return _this[functionName].apply(_this, arguments);
        };
      })(this);
      if (selector === '' && _isCustomEvent(event)) {
        this.subscribe(event, closure);
      } else {
        this.element.delegate(selector, event, closure);
      }
      if (this._closures == null) {
        this._closures = {};
      }
      this._closures["" + selector + "/" + event + "/" + functionName] = closure;
      return this;
    };

    Delegator.prototype._removeEvent = function(selector, event, functionName) {
      var closure;
      closure = this._closures["" + selector + "/" + event + "/" + functionName];
      if (selector === '' && _isCustomEvent(event)) {
        this.unsubscribe(event, closure);
      } else {
        this.element.undelegate(selector, event, closure);
      }
      delete this._closures["" + selector + "/" + event + "/" + functionName];
      return this;
    };

    Delegator.prototype.publish = function(name, args) {
      if (args == null) {
        args = [];
      }
      return this.trigger.apply(this, [name].concat(__slice.call(args)));
    };

    Delegator.prototype.subscribe = function(event, callback, context) {
      if (context == null) {
        context = this;
      }
      return this.on(event, callback, context);
    };

    Delegator.prototype.unsubscribe = function(event, callback, context) {
      if (context == null) {
        context = this;
      }
      return this.off(event, callback, context);
    };

    return Delegator;

  })();

  _parseEvents = function(eventsObj) {
    var event, events, functionName, sel, selector, _i, _ref;
    events = [];
    for (sel in eventsObj) {
      functionName = eventsObj[sel];
      _ref = sel.split(' '), selector = 2 <= _ref.length ? __slice.call(_ref, 0, _i = _ref.length - 1) : (_i = 0, []), event = _ref[_i++];
      events.push({
        selector: selector.join(' '),
        event: event,
        functionName: functionName
      });
    }
    return events;
  };

  natives = (function() {
    var key, specials, val;
    specials = (function() {
      var _ref, _results;
      _ref = $.event.special;
      _results = [];
      for (key in _ref) {
        if (!__hasProp.call(_ref, key)) continue;
        val = _ref[key];
        _results.push(key);
      }
      return _results;
    })();
    return "blur focus focusin focusout load resize scroll unload click dblclick\nmousedown mouseup mousemove mouseover mouseout mouseenter mouseleave\nchange select submit keydown keypress keyup error".split(/[^a-z]+/).concat(specials);
  })();

  _isCustomEvent = function(event) {
    event = event.split('.')[0];
    return $.inArray(event, natives) === -1;
  };

  BackboneEvents = require('backbone-events-standalone');

  BackboneEvents.mixin(Delegator.prototype);

  module.exports = Delegator;

}).call(this);
