// Generated by CoffeeScript 1.7.1
(function() {
  var $, Annotator, DebugStore, log, perform, uuid,
    __slice = [].slice;

  Annotator = require('annotator');

  $ = Annotator.Util.$;

  uuid = (function() {
    var counter;
    counter = -1;
    return function() {
      return counter += 1;
    };
  })();

  log = function() {
    var args;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    return console.debug.apply(console, ["DebugStore"].concat(__slice.call(args)));
  };

  perform = function(action, annotation) {
    var dfd;
    log(action, JSON.parse(JSON.stringify(annotation)));
    dfd = $.Deferred();
    dfd.resolve(annotation);
    return dfd.promise();
  };

  DebugStore = (function() {
    function DebugStore() {}

    DebugStore.prototype.create = function(annotation) {
      annotation.id = uuid();
      return perform('create', annotation);
    };

    DebugStore.prototype.update = function(annotation) {
      return perform('update', annotation);
    };

    DebugStore.prototype["delete"] = function(annotation) {
      return perform('destroy', annotation);
    };

    DebugStore.prototype.query = function(queryObj) {
      var dfd;
      dfd = $.Deferred();
      perform('query', queryObj);
      dfd.resolve([], {
        total: 0
      });
      return dfd.promise();
    };

    DebugStore.prototype.setHeader = function(key, value) {
      return log("would set header '" + key + "'='" + value + "'");
    };

    return DebugStore;

  })();

  Annotator.Plugin.register('DebugStore', DebugStore);

  module.exports = DebugStore;

}).call(this);
